#include<stdio.h>
#include<string.h>
#include<time.h>
#include <ftw.h>
#include <stdlib.h>
#include <errno.h>

#define MODULE_MAIN 1


#include "typedef.h"
#include "define.h"
#include "constant.h"
extern long int lec_date_dern_trait();
extern int liste_nomfich();

STNOMFICH *debut,*fin,*fiche;
STNOMFICH *debut_ddu,*fiche_ddu,*fin_ddu;
char rep_ddu[255];
	/* repertoire contenant les donnees a traiter */
booleen procedure_arret;
	/* arret de la procedure en cas de saturation de l'espace de stockage */
char rep_base[255];
	/* repertoire de travail de base */
char rep[100];

main(argc,argv)
int argc;
char *argv[];
{
long int secondes_dern_trait,sec_fich_le_plus_recent,sec_fich_le_plus_ancien;
struct tm *tmptr;
int ret_ftw;
struct stat st_ftw;
/* struct tm *pst_time;*/

FILE *fp_dernier;
FILE *fp_log;
char *ctime(),date_depouil[35],*ptr;
int i;
time_t nseconds;
int retour;
	/* retour de fonction */
char nomfich[25];
	/* nom du fichier LZH */
char date_fich[25];
	/* date du fichier LZH */
char fichier_log[100];
	/* chemin + nom fichier log */
char commande[255];
FILE *fp_lzh;
	/* fichier contenant le reopertoire de stockage du fichier lzh */
char compresseur[255];
char *s;

/* recuperation d'un eventuel repertoire de base pour */
/* la lecture et l'ecriture des fichiers */
/* ------------------------------------- */

if ( getenv("TRAIT_DDU")!= NULL)
	strcpy(rep_base,getenv("TRAIT_DDU"));
else
        /* si la variable d'environnement pour definir le repertoire */
        /* de base n'existe pas, on utilise le repertoire de base par defaut */
        /* defini dans constant.h */
	strcpy(rep_base,rep_base_defaut);


sprintf(rep,"%s/automat",rep_base);
sprintf(fichier_log,"%s/ddu_auto.log",rep);
 
sprintf(commande,"%s/rep_source_lzh.dat",rep);
fp_log=fopen(fichier_log,"a");

fprintf(fp_log,"------------------------------------------------------\n");
fprintf(fp_log,"*** Traitement transfert DDU\n");
fprintf(fp_log,"    Version: %5.2f\n",VERSION);
fprintf(fp_log,"    date   : %u\n",DATE_VERSION);


fprintf(fp_log,"Rpertoire de base pour le traitement des donnes:\n");
fprintf(fp_log,"rep_base= %s\n",rep_base);

sprintf(commande,"%s/rep_source_lzh.dat",rep);


if ( getenv("DDU")!= NULL)
	{
	strcpy(rep_ddu,getenv("DDU"));
	fprintf(fp_log,"Utilisation de $DUU pour dfinir le repertoire\n");
	fprintf(fp_log,"contenant les donnes  traiter:\n");
	fprintf(fp_log,"rep_ddu= %s\n",rep_ddu);
	}	
else if ( (fp_lzh = fopen(commande,"r")) != NULL)
	{
	fscanf(fp_lzh,"%s",rep_ddu);
	fclose(fp_lzh);
	fprintf(fp_log,"Utilisation du contenu du fichier %s\n",commande);
	fprintf(fp_log,"pour dfinir le repertoire contenant les \n");
	fprintf(fp_log,"donnes  traiter:\n");
	fprintf(fp_log,"rep_ddu= %s\n",rep_ddu);
	}
else
        /* si la variable d'environnement pour definir le repertoire qui */
        /* contient les donnes a traiter  n'existe pas, */
	/* on utilise le repertoire par defaut defini dans constant.h */
	{
	strcpy(rep_ddu,rep_ddu_defaut);
	fprintf(fp_log,"Utilisation du repertoire par defaut pour dfinir\n"); 
	fprintf(fp_log,"le repertoire contenant les donnes  traiter:\n");
	fprintf(fp_log,"rep_ddu= %s\n",rep_ddu);
	}	



/* calcul de la date courante */
nseconds=time(NULL);
ptr=ctime(&nseconds);
i=0;
while( ptr[i] != '\n' )
        date_depouil[i++]=ptr[i];
date_depouil[i]=0;
fprintf(fp_log,"    date: %s\n",date_depouil);

fprintf(fp_log,"\n");

fflush(fp_log);

procedure_arret = FAUX;

secondes_dern_trait = lec_date_dern_trait();
	/* on recupere la date du dernier traitement effectue */



debut = NULL;
fin = NULL;

ret_ftw=ftw(rep_ddu,(*liste_nomfich),3);
	/* on stocke les noms de fichiers du repertoire adele */
	/*  dans une liste chainee */
	/* STNOMFICH *debut,*fin,*fiche */

if(ret_ftw == -1)
	{
	fprintf(fp_log,"*** ERREUR acces repertoire adele reception DDU\n");
	perror(s);
	exit(255);
	};

debut_ddu = NULL;
fin_ddu = NULL;

liste_fich_a_taiter(
	secondes_dern_trait,
	&sec_fich_le_plus_recent,
	&sec_fich_le_plus_ancien);
	/* on recupere la liste des fichiers non encore traites */


fiche_ddu = debut_ddu;
fflush(fp_log);

while(fiche_ddu != NULL && procedure_arret == FAUX)
	/* on examine tous les fichiers trouves dans le repertoire */
	{
	/* on traite le fichier */
	printf("------> %s\n",fiche_ddu->nomfich);
	if (test_compression(fiche_ddu->nomfich,compresseur) == VRAI)
		/* si le fichier est compresse, on le decompresse et */
		/* on stocke les fichiers issus du decompressage */
		{
		sprintf(commande,"cp %s %s/lzh",fiche_ddu->nomfich,rep_base);
		system(commande);
		
		nseconds = fiche_ddu->secondes;
		tmptr = localtime(&nseconds);
		sprintf(date_fich,"%4.4d/%2.2d/%2.2d",tmptr->tm_year+1900,
			tmptr->tm_mon+1,tmptr->tm_mday);

		decompress(fiche_ddu->nomfich,compresseur);
			/* on decompresse le fichier */

		fprintf(fp_log," lancement de la procedure de depouillement:\n");
		
		sprintf(commande,
			"cd %s/new ; %s/depouil -batch -date %s -fich %s >>%s/ddu_auto.log",
			rep_base,rep_base,date_fich,fiche_ddu->nomfich,rep);
			/* depouil a partir de la version 2.0 */
		fprintf(fp_log,"%s\n",commande);
		fflush(fp_log);
		fclose(fp_log);
		system(commande);
		fp_log=fopen(fichier_log,"a");

		fprintf(fp_log,"\n lancement de la procedure d'insertion:\n");
		sprintf(commande,
			"cd %s/new ; %s/insere -date %s -fich %s >>%s/ddu_auto.log",
			rep_base,rep_base,date_fich,fiche_ddu->nomfich,rep);
		fprintf(fp_log,"%s\n",commande);
		fflush(fp_log);
		fclose(fp_log);
		system(commande);
		fp_log=fopen(fichier_log,"a");

		fprintf(fp_log,"Fin de procedure de traitement du fichier %s\n",
			fiche_ddu->nomfich);
		};

		if(procedure_arret == FAUX)

			fiche_ddu = fiche_ddu->suivant;
			/* on passe au fichier suivant */
	};

if(procedure_arret == FAUX)
	{

	if(sec_fich_le_plus_recent < secondes_dern_trait)
		sec_fich_le_plus_recent = sec_fich_le_plus_ancien;

	ecrit_date_dern_trait(sec_fich_le_plus_recent);
	}
else
	{
	fprintf(fp_log,"ARRET DE LA PROCEDURE DE TRAITEMENT!!! \n");
	};

	
libere_liste(debut_ddu,fin_ddu);
fclose(fp_log);

	
}
